unit View;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Main, Vcl.StdCtrls;

type
  TViewFrm = class(TForm)
    Field: TImage;
    FBtn: TButton;
    LBtn: TButton;
    RBtn: TButton;
    BBtn: TButton;
    TBtn: TButton;
    DownBtn: TButton;
    UpBtn: TButton;
    BlocksBtn: TButton;
    DBtn: TButton;
    TRBtn: TButton;
    TLBtn: TButton;
    procedure FBtnClick(Sender: TObject);
    procedure LBtnClick(Sender: TObject);
    procedure RBtnClick(Sender: TObject);
    procedure BBtnClick(Sender: TObject);
    procedure TBtnClick(Sender: TObject);
    procedure DownBtnClick(Sender: TObject);
    procedure UpBtnClick(Sender: TObject);
    procedure BlocksBtnClick(Sender: TObject);
    procedure DBtnClick(Sender: TObject);
    procedure TLBtnClick(Sender: TObject);
    procedure TRBtnClick(Sender: TObject);
  private
    { Private declarations }
    Layer: Integer;
  public
    { Public declarations }
    Tower: Array of Array of Array of TBlock;
    procedure Draw(M: Integer);
  end;

var
  ViewFrm: TViewFrm;

implementation

{$R *.dfm}

procedure TViewFrm.BBtnClick(Sender: TObject);
begin
  Draw(3);
end;

procedure TViewFrm.BlocksBtnClick(Sender: TObject);
begin
  Draw(7);
end;

procedure TViewFrm.DBtnClick(Sender: TObject);
begin
  Draw(8);
end;

procedure TViewFrm.UpBtnClick(Sender: TObject);
begin
  Draw(6);
end;

procedure DrawBlock(Canvas: TCanvas; x, y, dx, dy: Integer; Block: TBlock);
begin
  With Canvas do begin
    Brush.Color := Block.Color;
    Pen.Style := psClear;

    FillRect(Rect(
      (x + 1) * dx,
      (y + 1) * dy,
      (x + 2) * dx,
      (y + 2) * dy
    ));
  end;
end;

procedure TViewFrm.Draw;
var
  Buffer: TBitmap;
  i, j, k, Height, Bx, By: Integer;
begin
  UpBtn.Enabled := False;
  DownBtn.Enabled := False;
  TLBtn.Enabled := False;
  TRBtn.Enabled := False;

  Buffer := TBitmap.Create;
  try
    Buffer.Width := Field.Width;
    Buffer.Height := Field.Height;

    Height := 0;
    for i := 0 to High(Tower) do begin
      for j := 0 to High(Tower[i]) do begin
        if (Length(Tower[i][j]) > Height) then Height := Length(Tower[i][j]);
      end;
    end;

    if ((M >= 0) AND (M <= 3)) then begin
      Bx := Buffer.Width div (High(Tower) + 2);
      By := Buffer.Height div (Height + 2);
    end;

    case M of
      0: begin
        for i := 0 to High(Tower) do begin
          for j := 0 to High(Tower[i][0]) do begin
            DrawBlock(Buffer.Canvas, i, j, Bx, By, Tower[i][0][j]);
          end;
        end;
      end;

      4: begin
        UpBtn.Enabled := True;
        DownBtn.Enabled := True;
      end;

      8: begin
        TLBtn.Enabled := True;
        TRBtn.Enabled := True;
      end;
    end;

  finally
    Buffer.Free;
  end;
end;

procedure TViewFrm.FBtnClick(Sender: TObject);
begin
  Draw(0);
end;

procedure TViewFrm.LBtnClick(Sender: TObject);
begin
  Draw(1);
end;

procedure TViewFrm.RBtnClick(Sender: TObject);
begin
  Draw(2);
end;

procedure TViewFrm.TBtnClick(Sender: TObject);
begin
  Draw(4);
end;

procedure TViewFrm.TLBtnClick(Sender: TObject);
begin
  Draw(9);
end;

procedure TViewFrm.TRBtnClick(Sender: TObject);
begin
  Draw(10);
end;

procedure TViewFrm.DownBtnClick(Sender: TObject);
begin
  Draw(5);
end;

end.
